package api

import (
	"github.com/gin-gonic/gin"
	"github.guxuan/haibei/internal/mods/activity/biz"
	"github.guxuan/haibei/internal/mods/activity/schema"
	"github.guxuan/haibei/pkg/util"
)

type HouseArticle struct {
	HouseArticleBIZ *biz.HouseArticle
}

// @Tags 房刊模块
// @Security ApiKeyAuth
// @Summary Query house list
// @Param current query int true "pagination index" default(1)
// @Param pageSize query int true "pagination size" default(10)
// @Success 200 {object} util.ResponseResult{data=[]schema.HouseArticle}
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/house_articles [get]
func (a *HouseArticle) Query(c *gin.Context) {
	ctx := c.Request.Context()
	var params schema.HouseArticleQueryParam
	if err := util.ParseQuery(c, &params); err != nil {
		util.ResError(c, err)
		return
	}

	result, err := a.HouseArticleBIZ.Query(ctx, params)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResPage(c, result.Data, result.PageResult)
}

// @Tags 房刊模块
// @Security ApiKeyAuth
// @Summary Get house record by ID
// @Param id path string true "unique id"
// @Success 200 {object} util.ResponseResult{data=schema.HouseArticle}
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/house_articles/{id} [get]
func (a *HouseArticle) Get(c *gin.Context) {
	ctx := c.Request.Context()
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	item, err := a.HouseArticleBIZ.Get(ctx, id)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResSuccess(c, item)
}

// @Tags 房刊模块
// @Security ApiKeyAuth
// @Summary Create house record
// @Param body body schema.HouseArticleForm true "Request body"
// @Success 200 {object} util.ResponseResult{data=schema.HouseArticle}
// @Failure 400 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/house_articles [post]
func (a *HouseArticle) Create(c *gin.Context) {
	ctx := c.Request.Context()
	item := new(schema.HouseArticleForm)
	if err := util.ParseJSON(c, item); err != nil {
		util.ResError(c, err)
		return
	} else if err := item.Validate(); err != nil {
		util.ResError(c, err)
		return
	}

	result, err := a.HouseArticleBIZ.Create(ctx, item)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResSuccess(c, result)
}

// @Tags 房刊模块
// @Security ApiKeyAuth
// @Summary Update house record by ID
// @Param id path string true "unique id"
// @Param body body schema.HouseArticleForm true "Request body"
// @Success 200 {object} util.ResponseResult
// @Failure 400 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/house_articles/{id} [put]
func (a *HouseArticle) Update(c *gin.Context) {
	ctx := c.Request.Context()
	item := new(schema.HouseArticleForm)
	if err := util.ParseJSON(c, item); err != nil {
		util.ResError(c, err)
		return
	} else if err := item.Validate(); err != nil {
		util.ResError(c, err)
		return
	}
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	err = a.HouseArticleBIZ.Update(ctx, id, item)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResOK(c)
}

// @Tags 房刊模块
// @Security ApiKeyAuth
// @Summary Delete house record by ID
// @Param id path string true "unique id"
// @Success 200 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/house_articles/{id} [delete]
func (a *HouseArticle) Delete(c *gin.Context) {
	ctx := c.Request.Context()
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	err = a.HouseArticleBIZ.Delete(ctx, id)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResOK(c)
}
